      subroutine linsol(a,b,lda,kk,nv)
!     subroutine dmateq(a,b,kk,nv,d)
      implicit real*8 (a-h,o-z)
      real*8 a(lda,kk),b(lda,nv)
      d = 1.00000d0
      kkm=kk-1
      if (kkm.gt.0) go to 100
      do 90 i=1,nv
   90 b(1,i)=b(1,i)/a(1,1)
      return
  100 continue
      do 9 i=1, kkm
      s = 0.0d0
      do 1 j=i,kk
      r=abs(a(j,i))
      if(r.lt.s) goto 1
      s=r
      l=j
    1 continue
      if(l.eq.i) goto 5
      do 2 j=i,kk
      s=a(i,j)
      a(i,j)=a(l,j)
    2 a(l,j)=s
      do 3 j=1,nv
      s=b(i,j)
      b(i,j)=b(l,j)
    3 b(l,j)=s
      d = -d
    5 if(a(i,i) .eq. 0.0d0) go to 9
      ipo=i+1
      do 8 j=ipo,kk
      if(a(j,i) .eq. 0.0d0) go to 8
      s=a(j,i)/a(i,i)
      a(j,i) = 0.0d0
      do 6 k=ipo,kk
    6 a(j,k)=a(j,k)-a(i,k)*s
       do 7 k=1,nv
    7 b(j,k)=b(j,k)-b(i,k)*s
    8 continue
    9 continue
      do 10 i=1,kk
   10 d=d*a(i,i)
      kmo=kk-1
      do 12 k=1,nv
      b(kk,k)=b(kk,k)/a(kk,kk)
      do 12 i=1,kmo
      n=kk-i
      do 11 j=n,kmo
   11 b(n,k)=b(n,k)-a(n,j+1)*b(j+1,k)
   12 b(n,k)=b(n,k)/a(n,n)
      if(abs(d).lt.1.d-10) write(6,*) '**warning from linsol --',      &
      'determinant too small --',d
      return
       end
